/*
    Copyright Jon Baker 2019
*/
var sending = false;

(function (i, s, o, g, r, a, m) {
    i['GoogleAnalyticsObject'] = r; i[r] = i[r] || function () {
        (i[r].q = i[r].q || []).push(arguments)
    }, i[r].l = 1 * new Date(); a = s.createElement(o),
        m = s.getElementsByTagName(o)[0]; a.async = 1; a.src = g; m.parentNode.insertBefore(a, m)
})(window, document, 'script', 'https://www.google-analytics.com/analytics.js', 'ga');

function isBlank(data) {
    return ($.trim(data).length == 0);
}

function isValidUrl(url) {
    return /^(http(s)?:\/\/)?(www\.)?[a-z0-9]+([\-\.]{1}[a-z0-9]+)*\.[a-z]{2,5}(:[0-9]{1,5})?(\/.*)?$/.test(url);
}

function sendPost(text, cancel) {
    var url = "https://f5f74rq22e.execute-api.eu-west-2.amazonaws.com/production/papers/related/ex/20";

    function setDisabled() {
        $("#search").attr("disabled", "disabled");
        //$(".button").attr("disabled", "disabled");
        $(".button").html("Cancel");
    }

    function setEnabled() {
        $("#search").removeAttr("disabled");
        $(".button").removeAttr("disabled");
        $(".button").html("Search");
    }

    var isUrl = isValidUrl(text.trim());

    function joinAuthorsToString(authors) {
        var output = '';
        $.each(authors, function (i, item) {
            var name = item.name;
            if (i == authors.length - 1)
                output += name;
            else
                output += name + ", ";
        });
        return output;
    }

    function formatDate(date) {
        var monthNames = [
            "January", "February", "March",
            "April", "May", "June", "July",
            "August", "September", "October",
            "November", "December"
        ];

        var day = date.getDate();
        var monthIndex = date.getMonth();
        var year = date.getFullYear();

        return day + ' ' + monthNames[monthIndex] + ' ' + year;
    }

    function parseDate(date) {
        return formatDate(new Date(parseInt(date) * 1000));
    }

    function strip(html) {
        var stripedHtml = html.replace(/<[^>]+>/g, '');
        return stripedHtml;
    }

    function cleanupAbstract(abstract) {
        abstract = strip(abstract);
        abstract = abstract.replace(/\s\s+/g, ' ');
        while (abstract.charAt(0) === ' ') {
            abstract = abstract.substr(1);
        }
        return abstract;
    }

    function responseHandler(response) {
        var root = response.data;
        var str = "";
        var i;

        function getImageHtml(item, id) {
            if (isBlank(item.image_url) || item.image_url == "None")
                return "";
            if (item.image_url.startsWith("data:")) {
                $.ajax({
                    url: item.image_url,
                    processData: false,
                }).always(function (b64data) {
                    $("#image_" + id).attr("src", "data:image/png;base64," + b64data);
                });
                return "<div class=\"image\"><img src=\"" + item.image_url + "\" class=\"image-inner\" id=\"image_" + id + "\"/></div>";
            } else {
                return "<div class=\"image\"><img src=\"" + item.image_url + "\" class=\"image-inner\"/></div>";
            }
        }
        if (root == null || root.length == 0) {
            str = ("<div class=\"card card-1 card-noclick animation\">" +
                "<div class=\"title\">No results found</div>" +
                "<div class=\"text\">Try pasting an entire abstract into the search box, or enter more refined keywords</div>" +
                "</div>");
        } else {
            for (i = 0; i < root.length; i++) {
                str += (
                    "<a target=\"_blank\" id=\"" + root[i].id + "\" href=\"" + root[i].pdf_url + "\" class=\"card card-1 card-click animation " + (root[i].duplicate === true ? "duplicate" : "") + "\">" +
                    "<div class=\"title\">" + cleanupAbstract(root[i].title) + "</div>" +
                    "<div class=\"subtitle date\">" + parseDate(root[i].published_date) + "</div>" +
                    "<div class=\"subtitle\">" + joinAuthorsToString(root[i].authors) + "</div>" + getImageHtml(root[i], i) +
                    "<div class=\"text clamp\"><span>" + cleanupAbstract(root[i].abstract) +
                    "</span></div></a>");
            }
        }

        //console.log(str);
        $('#feed').html(str);
        var imgs = document.getElementsByTagName('img')
        for (var i = 0, j = imgs.length; i < j; i++) {
            imgs[i].onerror = function (e) {
                this.parentNode.removeChild(this);
            }
        }
        //        var images = document.getElementsByClassName('image-inner');
        //        new simpleParallax(images);
        sending = false;
    }

    if (cancel) {
        lastReq.abort();
        sending = false;
        setEnabled();
        return;
    }

    if (sending)
        return;

    sending = true;
    $('.folding-cube').fadeIn("fast");
    setDisabled();

    text = text.replace(/(\r\n|\n|\r)/gm, "");
    if (text.length > 1024)
        text = text.substr(0, 1023);

    lastReq = $.ajax({
        url: url,
        method: "POST",
        dataType: "json",
        headers: {
            "x-api-key": "I2221Qm0p71FUrnrhlKct437aMpcQB4P6UZmSLnK"
        },
        data: JSON.stringify({ "abstract": text }),
    }).done(function (response) {
        $('#spinner').fadeOut("fast");
        setEnabled();
        responseHandler(response);
        console.log(response);
        sending = false;
    }).fail(function (jqXHR, textStatus) {
        ga('send', 'event', 'Search', 'Fail', text);
        $('#spinner').fadeOut("fast");
        setEnabled();
        if (textStatus != "abort") {
            var str = ("<div class=\"card card-1 noclick animation\">" +
                "<div class=\"title\">An error occurred</div>" +
                "<div class=\"text\">" + textStatus + " " + jqXHR.responseText + "</div>" +
                "</div>");
            $('#feed').html(str);
        } else {
            $('#feed').html('');
        }
        sending = false;
        //alert(textStatus + " " + jqXHR.responseText);
    });

}



$(document).ready(function () {

    $("a").on("click", function () {
        var contentPanelId = $(this).attr("id");
        ga('send', 'event', 'Article', 'View', contentPanelId);
    });

    ga('create', 'UA-144901282-1', 'auto');
    ga('set', 'checkProtocolTask', null);
    ga('send', 'pageview', '/popup');

    function getSelection() {
        var seltxt = null;
        if (window.getSelection) {
            seltxt = window.getSelection();
        } else if (document.getSelection) {
            seltxt = document.getSelection();
        } else if (document.selection) {
            seltxt = document.selection.createRange().text;
        }
        else return;
        return seltxt;
    }

    function getDOM() {
        //You can play with your DOM here or check URL against your regex

        var str = document.querySelector("h1").textContent.trim();
        //        var elems = document.getElementsByTagName("h1");
        //        for(var i = 0; i < elems.length; i++){
        //            str += elems[i].textContent + " ";
        //        }
        //        elems = document.getElementsByTagName("h2");
        //        for(var i = 0; i < elems.length; i++){
        //            str += elems[i].textContent + " ";
        //        }
        //        elems = document.getElementsByTagName("h3");
        //        for(var i = 0; i < elems.length; i++){
        //            str += elems[i].textContent + " ";
        //        }
        //alert(str);
        return str;
    }


    chrome.tabs.executeScript({
        code: "getSelection().toString()"
    }, function (selection) {
        var str = selection;
        if (!isBlank(str)) {
            $('#search').val(str);
            $('#search').animate({
                "height": "+=100",
            }, 500, function () {

            });
            ga('send', 'event', 'Search', 'Selection', str);
            sendPost($('#search').val());
        } else {
            //We have permission to access the activeTab, so we can call chrome.tabs.executeScript:
            chrome.tabs.executeScript({
                code: '(' + getDOM + ')();' //argument here is a string but function.toString() returns function's code
            }, (results) => {
                var html = results[0];
                if (!isBlank(html)) {
                    $('#search').val(html);
                    $('#search').animate({
                        "height": "+=100",
                    }, 500, function () {

                    });
                    ga('send', 'event', 'Search', 'Selection', html);
                    sendPost(String(html));
                }
            });
        }

    });


    $('#search').focus(function () {
        $(this).animate({
            "height": "+=100",
        }, 500, function () {

        });
    });

    //    $('#search').blur(function () {
    //        $(this).animate({
    //            "height": "-=100",
    //        }, 500, function () {
    //
    //        });
    //    });


    $('.button').on('click', function () {
        var element = $('#search');
        setTimeout(function () {
            var text = $(element).val();

            // do something with text
            if ($('.button').html() == "Cancel") {
                ga('send', 'event', 'Search', 'Cancel', text);
                sendPost(text, true);
            }
            else if (text.length > 0) {
                ga('send', 'event', 'Search', 'Manual', text);
                sendPost(text, false);
            }
        }, 50);
    });

    $('#search').on('paste', function () {
        var element = this;
        setTimeout(function () {
            var text = $(element).val();
            ga('send', 'event', 'Search', 'Paste', text);
            // do something with text
            if (text.length > 0)
                sendPost(text, false);
        }, 50);
    });

});
